/***************************************************************************
 * Structured Markov Chains Solver       [  SMCSolver  ]                   *
 * Dario Bini, Beatrice Meini, Sergio Steffe'                              *
 * dario.bini@unipi.it, beatrice.meini@unipi.it, steffe@cs.dm.unipi.it     *
 * Dipartimento di Matematica - Universita' di Pisa                        *
 * Largo Pontecorvo 5                                                      *
 * 56127 Pisa                                                              *
 * Italy                                                                   *
 * Version 2.2 - March  2024                                             *
***************************************************************************

 *
 *  padwrite.h -  using threads and writing asyncronously FIFO to write Notepad
 *
 */

/* prototypes padwrite.c */
gint fifo_inwin(void);
void append_fifo_(char *text);
gint selection_uptodaten(void);
gint delayed_close(void);
gint pi_delayed_close(void);
gint delayed_examples_close(void);


/* prototypes callbacks.c */
void clean_statusb(void);

/* globals padwrite.c */
extern int  my_iret;
extern pthread_t my_thread;
/* pthread_mutex_t my_mutex */

/* globals callback.c */
extern int is_parameters;   /* 0 = normal 1=to close */
extern int is_pi_parameters; /* 0=not open  1=open */


/* globals interface.c */
extern GtkWidget *menuitem_qbd;
extern GtkWidget *menuitem_mg1;
extern GtkWidget *menuitem_gim1;
extern GtkWidget *textview;
int fifosi, fifoin, fifoout, fifomax;                 /* using FIFO to write Notepad in Main Window asyncronously */
char fifostr[64000][120];                                 /* using FIFO to write Notepad in Main Window asyncronously */
int is_completed;                                     /* 1 if computation did complete 0 if it is not completed yet */
extern int is_running;      /* 0 = not running 1 = running */
extern GtkWidget *handlebox_s; /* to show the situation of all choice made */
GtkWidget *label_s1, *label_s2, *label_s3, *label_s4, *label_s5, *label_s6; /* to keep situation up to date */
extern GtkWidget * window_parameters;
extern GtkWidget * window_pi_parameters;
extern GtkWidget *window_examples;
extern int is_examples_open; /* 0 = not open 1 = open */
extern int is_pi_parameters_open; /* 0=not open  1=open */
extern struct algorithms_str algorithms_choice;
extern struct goals_str goals_choice;
extern struct running_problem_str committed,selected; /* we save data here after successfully allocate the matrices with the data */

/*********************************************/
